﻿using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using System.Collections.Generic;
using WebApplication.model;

// For more information on enabling Web API for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860

namespace WebApplication.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class ValuesController : ControllerBase
    {

        // GET api/<ValuesController>/5
        [HttpGet("{id}")]
        public string Get(string id)
        {
            dingApi dingApi = new dingApi();
            dingApi.DingToken();
            //dingApi.processInstances();
            //printInfo printInfo = new printInfo();
            //List<printInfo.Person> peopledata = new List<printInfo.Person>();
            //printInfo.WriteDataToExcelTemplate("E:/jsjPrintTemplate/XBPrintTemplate.xlsx", "E:/jsjPrintTemplate/XBPrintTemplate"+DateTime.Now+".xlsx", peopledata.ToString(), "采购申请");
            return "value";
        }

        // GET api/<ValuesController>/5
        /// <summary>
        /// OA审批单
        /// </summary>
        /// <param name="processInstanceId">OA审批单号</param>
        /// <param name="name">OA单据名称</param>
        /// <returns></returns>
        [HttpGet("{processInstanceId},{name}")]
        public string Get(string processInstanceId,string name)
        { 
            dingApi dingApi = new dingApi();
            personOA oA = new personOA();
            string token = dingApi.DingToken();
            string process = dingApi.processInstances(processInstanceId);
            switch (name)
            {
                case "内部工作流转":
                    List<personOA.Person> listIWG = new List<personOA.Person>();
                    listIWG.Add(oA.Roleioat(process, "内部工作流转"));
                    new cyAPI().commonMethod(token, JsonConvert.SerializeObject(listIWG[0]).ToString(),listIWG[0].F0000005, "F0000005");
                    break;
            }
            return "true";
        }

        
    }
}
